Timezone Behavior in DateTimePicker Control

18 Nov 20184 minutes to read

The DateTimePicker component displays and maintains date and time values based on the client system’s local time zone. When a user selects a date and time, it is stored using the system’s time zone at the time of selection, ensuring consistent and predictable behavior.

Important: If the system time zone changes after a date-time is selected, the DateTimePicker does not automatically update the displayed value. The component preserves the original selection, maintaining a stable user experience.

serverTimezoneOffset

The serverTimezoneOffset property specifies the server’s time zone offset from UTC in hours or fractional hours, enabling correct interpretation of server-provided date-time values on the client.

Scenario UTC Offset Example
Eastern Standard Time -5 serverTimezoneOffset={-5}
Fractional offset -4.5 serverTimezoneOffset={-4.5} (UTC-4:30)
India Standard Time 5.5 serverTimezoneOffset={5.5} (UTC+5:30)

Scope: The serverTimezoneOffset property applies only to pre-bound values during initialization or data binding. It does not affect date-times selected by the user during runtime or entered directly in the input field.

Edge Cases & Considerations

  • Daylight Saving Time (DST): The component uses the system’s DST information; no manual DST adjustment is required. However, when migrating across DST boundaries, ensure server times are correctly UTC-adjusted.
  • UTC±0 (GMT/UTC): Specify serverTimezoneOffset={0} when the server operates in UTC.
  • Dynamic timezone changes: System time zone changes after date-time selection do not affect already-selected values; users must re-select dates to reflect the new time zone.

The following examples demonstrate DateTimePicker timezone handling:

[Class-component]

// import the datetimepickercomponent
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
export default class App extends React.Component {
    render() {
        return <DateTimePickerComponent id="datetimepicker" placeholder="Select a date and time" serverTimezoneOffset={5.5}/>;
    }
}
ReactDOM.render(<App />, document.getElementById('element'));
// import the datetimepickercomponent
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from 'react';
import * as ReactDOM from 'react-dom';

export default class App extends React.Component<{}, {}> {
    public render() {
        return <DateTimePickerComponent id="datetimepicker" placeholder="Select a date and time" serverTimezoneOffset={5.5}/>;
    }
}
ReactDOM.render(<App />, document.getElementById('element'));

[Functional-component]

// import the datetimepickercomponent
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from 'react';
import * as ReactDOM from 'react-dom';
function App() {
    return <DateTimePickerComponent id="datetimepicker" placeholder="Select a date and time" value={new Date()} serverTimezoneOffset={5.5}/>;
}
ReactDOM.render(<App />, document.getElementById('element'));
// import the datetimepickercomponent
import { DateTimePickerComponent } from '@syncfusion/ej2-react-calendars';
import * as React from 'react';
import * as ReactDOM from 'react-dom';

function App() {
    return <DateTimePickerComponent id="datetimepicker" placeholder="Select a date and time" value={new Date()} serverTimezoneOffset={5.5}/>;
}
ReactDOM.render(<App />, document.getElementById('element'));

Timezone Behavior in DateTimePicker Control

18 Nov 20182 minutes to read

The DateTimePicker component displays and maintains the selected date and time value based on the client system’s current time zone. When a user selects a value, it is stored and rendered using the local time zone of the system at the time of selection. This ensures that the value remains consistent and predictable during user interaction.

NOTE

if the system time zone is changed dynamically after a value is selected, the DateTimePicker will not update or shift the selected value. The component preserves the original selection, ensuring a stable and reliable user experience.

serverTimezoneOffset

The serverTimezoneOffset property allows you to specify the server’s time zone offset from UTC in hours or fractional hours. This is useful when binding values from the server to ensure they are interpreted correctly on the client side.

  • The value should be a number representing the offset from UTC.
  • Examples:
    • -5 → UTC-5 (Eastern Standard Time)
    • -4.5 → UTC-4:30 (Afghanistan Time)
    • 5.5 → UTC+5:30 (India Standard Time)

NOTE

The serverTimezoneOffset property is applicable only for pre-bound values (i.e., values set during initialization or data binding). It does not affect values selected by the user during runtime.

<template>
    <div id="app">
      <div class='wrapper'>
         <ejs-datetimepicker :placeholder="waterMark" :serverTimezoneOffset="serverOffset" :value="dateVal" ></ejs-datetimepicker>
      </div>
    </div>
</template>
<script>

import { DateTimePickerComponent } from '@syncfusion/ej2-vue-calendars';

export default {
name: "App",
components: {
"ejs-datetimepicker":DateTimePickerComponent
},
    data () {
    return {
      waterMark : 'Select a datetime',
      serverOffset : 5.5,
      dateval: new Date()
      
    }
  }
}
</script>
<style>
@import '../node_modules/@syncfusion/ej2-base/styles/material.css';
@import '../node_modules/@syncfusion/ej2-buttons/styles/material.css';
@import '../node_modules/@syncfusion/ej2-inputs/styles/material.css';
@import '../node_modules/@syncfusion/ej2-popups/styles/material.css';
@import '../node_modules/@syncfusion/ej2-lists/styles/material.css';
@import "../node_modules/@syncfusion/ej2-vue-calendars/styles/material.css";
   .wrapper {
    max-width: 250px;
    margin: 0 auto;
  }
</style>

Timezone Behavior in DateTimePicker Control

18 Nov 20182 minutes to read

The DateTimePicker component displays and maintains the selected date and time value based on the client system’s current time zone. When a user selects a value, it is stored and rendered using the local time zone of the system at the time of selection. This ensures that the value remains consistent and predictable during user interaction.

NOTE

if the system time zone is changed dynamically after a value is selected, the DateTimePicker will not update or shift the selected value. The component preserves the original selection, ensuring a stable and reliable user experience.

serverTimezoneOffset

The serverTimezoneOffset property allows you to specify the server’s time zone offset from UTC in hours or fractional hours. This is useful when binding values from the server to ensure they are interpreted correctly on the client side.

  • The value should be a number representing the offset from UTC.
  • Examples:
    • -5 → UTC-5 (Eastern Standard Time)
    • -4.5 → UTC-4:30 (Afghanistan Time)
    • 5.5 → UTC+5:30 (India Standard Time)

NOTE

The serverTimezoneOffset property is applicable only for pre-bound values (i.e., values set during initialization or data binding). It does not affect values selected by the user during runtime.

The following example illustrates the output in your browser

import { NgModule } from '@angular/core'
import { BrowserModule } from '@angular/platform-browser'
import { FormsModule } from '@angular/forms'
import { DateTimePickerModule } from '@syncfusion/ej2-angular-calendars'




import { Component } from "@angular/core";

@Component({
imports: [
        
        DateTimePickerModule,
        FormsModule
    ],


standalone: true,
  selector: 'app-root',
  template: `<ejs-datetimepicker [value]='date' [format]="'yyyy-MM-dd hh:mm'" [serverTimezoneOffset]="serverOffset">></ejs-datetimepicker>`
})
export class AppComponent {
  public date: Date = new Date();
  public serverOffset: number = 5.5;
  constructor() {}
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));